 
#include "Share.h"

class  THICOM:public TDebug
{
   private:
      HANDLE hSerial;
     
   public:
    int _prop_ComPort;
    int _prop_BaudRate;
    BYTE _prop_Parity;
    bool _prop_CrLf;
     int _prop_TimeOut;
     THI_Event *_data_Data;
     THI_Event *_data_ComPort;
     THI_Event *_data_BaudRate;
     THI_Event *_event_onWrite;
     THI_Event *_event_onRead;
     THI_Event *_event_onError;
      
  HI_WORK_LOC(THICOM,_work_doOpen)
   {  
       string prt=L"COM" ;
       string pnt=L":";   
      int nm = ReadInteger(_Data,_data_ComPort,_prop_ComPort);
        string nmb=IntToStr(nm);
       string sPortName = prt+nmb+pnt;
       int rate = ReadInteger(_Data,_data_BaudRate,_prop_BaudRate);
       int out = ReadInteger(_Data,0,_prop_TimeOut);
     hSerial = CreateFile(PChar(sPortName),GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
     if(hSerial==INVALID_HANDLE_VALUE)
      { string err=L"Serial port does not exist"; _hi_onEvent(_event_onError,err);}
            
	 else  {	        
                   
     DCB PortDCB;
// Initialize the DCBlength member. 
PortDCB.DCBlength = sizeof (DCB); 

// Get the default port setting information.
   GetCommState (hSerial, &PortDCB);
   
PortDCB.BaudRate = rate;              // Current baud 
PortDCB.fBinary = TRUE;               // Binary mode; no EOF check 
PortDCB.fParity = TRUE;               // Enable parity checking 
PortDCB.fOutxCtsFlow = FALSE;         // No CTS output flow control 
PortDCB.fOutxDsrFlow = FALSE;         // No DSR output flow control 
PortDCB.fDtrControl = DTR_CONTROL_ENABLE; 
                                      // DTR flow control type 
PortDCB.fDsrSensitivity = FALSE;      // DSR sensitivity 
PortDCB.fTXContinueOnXoff = TRUE;     // XOFF continues Tx 
PortDCB.fOutX = FALSE;                // No XON/XOFF out flow control 
PortDCB.fInX = FALSE;                 // No XON/XOFF in flow control 
PortDCB.fErrorChar = FALSE;           // Disable error replacement 
PortDCB.fNull = FALSE;                // Disable null stripping 
PortDCB.fRtsControl = RTS_CONTROL_ENABLE; 
                                      // RTS flow control 
PortDCB.fAbortOnError = FALSE;        // Do not abort reads/writes on 
                                      // error
PortDCB.ByteSize = 8;                 // Number of bits/byte, 4-8 
PortDCB.Parity = _prop_Parity;            // 0-4=no,odd,even,mark,space 
PortDCB.StopBits = ONESTOPBIT;        // 0,1,2 = 1, 1.5, 2 

// Configure the port according to the specifications of the DCB  structure.
                       if (!SetCommState (hSerial, &PortDCB))
                             {
                            // Could not configure the serial port.
  MessageBox (NULL,L"Unable to configure the serial port",L"Error", MB_OK);

                            }
         COMMTIMEOUTS CommTimeouts;
GetCommTimeouts (hSerial, &CommTimeouts);

// Change the COMMTIMEOUTS structure settings.
CommTimeouts.ReadIntervalTimeout = MAXDWORD;  
CommTimeouts.ReadTotalTimeoutMultiplier = 0;  
CommTimeouts.ReadTotalTimeoutConstant = 0;    
CommTimeouts.WriteTotalTimeoutMultiplier = out;  
CommTimeouts.WriteTotalTimeoutConstant = 1000;    

// Set the timeout parameters for all read and write operations on the port. 
              if (!SetCommTimeouts (hSerial, &CommTimeouts))
             {
  // Could not set the timeout parameters.
  MessageBox (NULL,L"Unable to set the timeout parameters",L"Error", MB_OK);
  
          }
       } 
    }   
    
   HI_WORK_LOC(THICOM,_work_doClose)
            {CloseHandle(hSerial);}
            
            
  HI_WORK_LOC(THICOM,_work_doRXClear)
           {  PurgeComm(hSerial,PURGE_RXCLEAR); }         
    
   HI_WORK_LOC(THICOM,_work_doWrite)
      { 
        DWORD dwBytesWritten=0;
         if(hSerial==INVALID_HANDLE_VALUE)
          _hi_onEvent(_event_onWrite,(int)dwBytesWritten);
          else {
              char cr='\r\n';  
             string dt=ReadString(_Data,_data_Data,SNULL); 
                 int len=dt.Length()+1;  
                 for (int i=0;i<len;i++)
                    { 
              unsigned int data;
              if( dt.Empty() ) data = 0;
               else data = (int)dt[i]; 
        DWORD dwSize = sizeof(data);    
          WriteFile (hSerial,&data,1,&dwBytesWritten,NULL);
                    }
               if(_prop_CrLf)
           WriteFile (hSerial,&cr,4,&dwBytesWritten,NULL);   
            _hi_onEvent(_event_onWrite,(int)len-1 );
              }   
      }
          	     
   HI_WORK_LOC(THICOM,_work_doRead)
             {    
                 DWORD iSize;
               char sReceivedChar;
                 HI_RSTRING buf[2];
                 string fn; 
            if(hSerial!=INVALID_HANDLE_VALUE)
               {   
                while (iSize>0)
            {
           bool ReadStat= ReadFile(hSerial, &sReceivedChar, 1, &iSize,NULL);
                     
                        buf[0] = sReceivedChar;
                           buf[1] = 0;
                     
                       fn+=buf;
                    }
           }
        _hi_onEvent(_event_onRead,string(fn));
        delete buf;     
     }
     
   HI_WORK_LOC(THICOM,_work_doDTR) 
           {      
             bool bit=ReadInteger(_Data,0,0); 
           if (hSerial == INVALID_HANDLE_VALUE)
           return;
           if(bit)        
        EscapeCommFunction(hSerial, SETDTR);
        else
        EscapeCommFunction(hSerial, CLRDTR);
           } 
                    
                    
   HI_WORK_LOC(THICOM,_work_doRTS)
         {
              bool bit=ReadInteger(_Data,0,0); 
            if (hSerial == INVALID_HANDLE_VALUE)
           return;
           if(bit)  
        EscapeCommFunction(hSerial, SETRTS);
        else
        EscapeCommFunction(hSerial, CLRRTS);
         }         
};

//#############################################################################
   